from qtido import *

def ligne_vide(n):
    res = []
    for i in range(n):
        res.append(0)
    return res

def grille_vide(m, n):
    res = []
    for i in range(m):
        res.append(ligne_vide(n))
    return res

def remplir_pour_tester(gr):
    for i in range(7):
        gr[i][i] = i+1
        gr[i*2][i] = i+1

def afficher(f, gr, px):
    H = len(gr)
    for i in range(len(gr)):
        ligne = gr[i]
        for j in range(len(ligne)):
            v = ligne[j]
            if v == 0: continue
            elif v == 1: couleur(f, 0, 1, 1)
            elif v == 2: couleur(f, 1, 1, 0)
            elif v == 3: couleur(f, 1, 0, 1)
            elif v == 4: couleur(f, 0, 1, 0)
            elif v == 5: couleur(f, 1, 0, 0)
            elif v == 6: couleur(f, 0, 0, 1)
            elif v == 7: couleur(f, 1, 0.5, 0)
            rectangle(f, j*px+1, (H-i-1)*px+1, (j+1)*px-1, (H-i)*px-1)

def afficher_piece(f, px, H, p, pos):
    for ii in range(4):
        ligne = p[ii]
        i = ii + pos[0]
        for jj in range(4):
            v = ligne[jj]
            j = jj + pos[1]
            couleur(f, 0.9, 0.9, 0.9)
            if v > 0:
                rectangle(f, j*px+1, (H-i-1)*px+1, (j+1)*px-1, (H-i)*px-1)

def tourner_piece_droite(p):
    res = grille_vide(4, 4)
    for ii in range(4):
        for jj in range(4):
            res[ii][jj] = p[ii][jj] # faux
    return res

def probleme(gr, p, pos):
    H = len(gr)
    W = len(gr[1])
    return False

def integrer_piece(nv, gr, p, pos):
    H = len(gr)

def retirer_ligne(gr, m):
    W = len(gr[m])
    del gr[m]
    gr.append(ligne_vide(W))

def retirer_lignes_pleines(gr):
    H = len(gr)
    return 0

def test_creer_vide():
    assert ligne_vide(1) == [0]
    assert ligne_vide(4) == [0, 0, 0, 0]
    assert ligne_vide(5) == [0, 0, 0, 0, 0]

    assert grille_vide(1,1) == [[0]]
    assert grille_vide(2,2) == [[0, 0], [0, 0]]
    assert grille_vide(3,2) == [[0, 0], [0, 0], [0, 0]]
    assert grille_vide(2,4) == [[0, 0, 0, 0], [0, 0, 0, 0]]

def test_retirer_ligne():
    g = [[0, 1, 2], 
         [3, 4, 5],
         [6, 7, 0]]
    g2= [[0, 1, 2], 
         [3, 4, 5],
         [0, 0, 0]]
    g3= [[3, 4, 5], 
         [0, 0, 0],
         [0, 0, 0]]
    retirer_ligne(g, 2)
    assert g == g2
    retirer_ligne(g, 0)
    assert g == g3
    g = [[0, 1, 2], 
         [3, 4, 5],
         [6, 7, 0]]
    retirer_ligne(g, 0)
    retirer_ligne(g, 1)
    assert g == g3

test_creer_vide()
test_retirer_ligne()
